/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Contents of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.197 - (show annotations) (download)
Thu Oct 26 06:55:31 2006 UTC (12 years, 7 months ago) by vapier
Branch: MAIN
Changes since 1.196: +1 -2 lines
move IUSE=gcc64 to linux-headers ebuild

1 # Copyright 1999-2005 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.196 2006/10/24 23:45:35 vapier Exp $
4
5 # Description: kernel.eclass rewrite for a clean base regarding the 2.6
6 # series of kernel with back-compatibility for 2.4
7 #
8 # Maintainer: John Mylchreest <johnm@gentoo.org>
9 #
10 # Please direct your bugs to the current eclass maintainer :)
11
12 # added functionality:
13 # unipatch - a flexible, singular method to extract, add and remove patches.
14
15 # A Couple of env vars are available to effect usage of this eclass
16 # These are as follows:
17 #
18 # K_USEPV - When setting the EXTRAVERSION variable, it should
19 # add PV to the end.
20 # this is useful for thigns like wolk. IE:
21 # EXTRAVERSION would be something like : -wolk-4.19-r1
22 # K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
23 # automatically set within the kernel Makefile
24 # K_NOUSENAME - if this is set then EXTRAVERSION will not include the
25 # first part of ${PN} in EXTRAVERSION
26 # K_NOUSEPR - if this is set then EXTRAVERSION will not include the
27 # anything based on ${PR}.
28 # K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
29 # ck-sources, ac-sources) it will use PR (ie: -r5) as
30 # the patchset version for
31 # and not use it as a true package revision
32 # K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
33 # postinst and can be used to carry additional postinst
34 # messages
35 # K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's
36 # K_SYMLINK - if this is set, then forcably create symlink anyway
37 #
38 # K_DEFCONFIG - Allow specifying a different defconfig target.
39 # If length zero, defaults to "defconfig".
40 # K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
41 # combination of "base" and "extras"
42 # K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
43 # A value of "5" would apply genpatches-2.6.12-5 to
44 # my-sources-2.6.12.ebuild
45
46 # H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
47 # can be supported by the headers ebuild
48
49 # UNIPATCH_LIST - space delimetered list of patches to be applied to the
50 # kernel
51 # UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
52 # on "<passedstring>*" and not "<passedno#>_*"
53 # - this should _NOT_ be used from the ebuild as this is
54 # reserved for end users passing excludes from the cli
55 # UNIPATCH_DOCS - space delimemeted list of docs to be installed to
56 # the doc dir
57 # UNIPATCH_STRICTORDER - if this is set places patches into directories of
58 # order, so they are applied in the order passed
59
60 inherit eutils toolchain-funcs versionator multilib
61 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
62
63 # Added by Daniel Ostrow <dostrow@gentoo.org>
64 # This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
65 # I will remove it when I come up with something more reasonable.
66 [[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
67
68 export CTARGET=${CTARGET:-${CHOST}}
69 if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
70 export CTARGET=${CATEGORY/cross-}
71 fi
72
73 HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
74 LICENSE="GPL-2"
75
76 # No need to run scanelf/strip on kernel sources/headers (bug #134453).
77 RESTRICT="binchecks strip"
78
79 # set LINUX_HOSTCFLAGS if not already set
80 [[ -z ${LINUX_HOSTCFLAGS} ]] && \
81 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
82
83 # debugging functions
84 #==============================================================
85 # this function exists only to help debug kernel-2.eclass
86 # if you are adding new functionality in, put a call to it
87 # at the start of src_unpack, or during SRC_URI/dep generation.
88 debug-print-kernel2-variables() {
89 debug-print "PVR: ${PVR}"
90 debug-print "CKV: ${CKV}"
91 debug-print "OKV: ${OKV}"
92 debug-print "KV: ${KV}"
93 debug-print "KV_FULL: ${KV_FULL}"
94 debug-print "RELEASETYPE: ${RELEASETYPE}"
95 debug-print "RELEASE: ${RELEASE}"
96 debug-print "UNIPATCH_LIST_DEFAULT: ${UNIPATCH_LIST_DEFAULT} "
97 debug-print "UNIPATCH_LIST_GENPATCHES: ${UNIPATCH_LIST_GENPATCHES} "
98 debug-print "UNIPATCH_LIST: ${UNIPATCH_LIST}"
99 debug-print "S: ${S}"
100 debug-print "KERNEL_URI: ${KERNEL_URI}"
101 }
102
103 #Eclass functions only from here onwards ...
104 #==============================================================
105 handle_genpatches() {
106 local tarball
107 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1
108
109 for i in ${K_WANT_GENPATCHES} ; do
110 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
111 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
112 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
113 done
114 }
115
116 detect_version() {
117 # this function will detect and set
118 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
119 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
120 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
121
122 if [[ -n ${KV_FULL} ]]; then
123 # we will set this for backwards compatibility.
124 KV=${KV_FULL}
125
126 # we know KV_FULL so lets stop here. but not without resetting S
127 S=${WORKDIR}/linux-${KV_FULL}
128 return
129 fi
130
131 # CKV is used as a comparison kernel version, which is used when
132 # PV doesnt reflect the genuine kernel version.
133 # this gets set to the portage style versioning. ie:
134 # CKV=2.6.11_rc4
135 CKV=${CKV:-${PV}}
136 OKV=${OKV:-${CKV}}
137 OKV=${OKV/_beta/-test}
138 OKV=${OKV/_rc/-rc}
139 OKV=${OKV/-r*}
140 OKV=${OKV/_p*}
141
142 KV_MAJOR=$(get_version_component_range 1 ${OKV})
143 KV_MINOR=$(get_version_component_range 2 ${OKV})
144 KV_PATCH=$(get_version_component_range 3 ${OKV})
145
146 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
147 KV_EXTRA=$(get_version_component_range 4- ${OKV})
148 KV_EXTRA=${KV_EXTRA/[-_]*}
149 else
150 KV_PATCH=$(get_version_component_range 3- ${OKV})
151 fi
152 KV_PATCH=${KV_PATCH/[-_]*}
153
154 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
155
156 RELEASE=${CKV/${OKV}}
157 RELEASE=${RELEASE/_beta}
158 RELEASE=${RELEASE/_rc/-rc}
159 RELEASE=${RELEASE/_pre/-pre}
160 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
161 RELEASETYPE=${RELEASE//[0-9]}
162
163 # Now we know that RELEASE is the -rc/-git
164 # and RELEASETYPE is the same but with its numerics stripped
165 # we can work on better sorting EXTRAVERSION.
166 # first of all, we add the release
167 EXTRAVERSION="${RELEASE}"
168 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
169 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
170
171 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
172 if [[ -n "${K_NOUSEPR}" ]]; then
173 # Don't add anything based on PR to EXTRAVERSION
174 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
175 elif [[ -n ${K_PREPATCHED} ]]; then
176 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
177 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
178 elif [[ "${ETYPE}" = "sources" ]]; then
179 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
180 # For some sources we want to use the PV in the extra version
181 # This is because upstream releases with a completely different
182 # versioning scheme.
183 case ${PN/-*} in
184 wolk) K_USEPV=1;;
185 vserver) K_USEPV=1;;
186 esac
187
188 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
189 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
190 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
191 fi
192 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
193
194 # The only messing around which should actually effect this is for KV_EXTRA
195 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
196 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
197 if [[ -n ${KV_EXTRA} ]]; then
198 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
199 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2
200 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
201 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
202 fi
203
204 # We need to set this using OKV, but we need to set it before we do any
205 # messing around with OKV based on RELEASETYPE
206 KV_FULL=${OKV}${EXTRAVERSION}
207
208 # we will set this for backwards compatibility.
209 S=${WORKDIR}/linux-${KV_FULL}
210 KV=${KV_FULL}
211
212 # -rc-git pulls can be achieved by specifying CKV
213 # for example:
214 # CKV="2.6.11_rc3_pre2"
215 # will pull:
216 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
217
218 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
219 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
220 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
221 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
222 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
223 fi
224
225 if [[ ${RELEASETYPE} == -git ]]; then
226 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
227 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
228 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
229 fi
230
231 if [[ ${RELEASETYPE} == -rc-git ]]; then
232 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
233 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
234 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
235 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
236 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
237 fi
238
239 debug-print-kernel2-variables
240
241 handle_genpatches
242 }
243
244 kernel_is() {
245 [[ -z ${OKV} ]] && detect_version
246 local operator test value x=0 y=0 z=0
247
248 case ${1} in
249 lt) operator="-lt"; shift;;
250 gt) operator="-gt"; shift;;
251 le) operator="-le"; shift;;
252 ge) operator="-ge"; shift;;
253 eq) operator="-eq"; shift;;
254 *) operator="-eq";;
255 esac
256
257 for x in ${@}; do
258 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
259 value="${value}${x}"
260 z=$((${z} + 1))
261
262 case ${z} in
263 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
264 test="${test}${KV_MAJOR}";;
265 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
266 test="${test}${KV_MINOR}";;
267 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
268 test="${test}${KV_PATCH}";;
269 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
270 esac
271 done
272
273 [ ${test} ${operator} ${value} ] && return 0 || return 1
274 }
275
276 kernel_is_2_4() {
277 kernel_is 2 4
278 }
279
280 kernel_is_2_6() {
281 kernel_is 2 6 || kernel_is 2 5
282 }
283
284 # Capture the sources type and set DEPENDs
285 if [[ ${ETYPE} == sources ]]; then
286 DEPEND="!build? ( sys-apps/sed
287 >=sys-devel/binutils-2.11.90.0.31 )"
288 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
289 sys-devel/make )
290 virtual/dev-manager"
291
292 PROVIDE="virtual/linux-sources"
293 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
294
295 SLOT="${PVR}"
296 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
297 IUSE="symlink build"
298 elif [[ ${ETYPE} == headers ]]; then
299 DESCRIPTION="Linux system headers"
300
301 # Since we should NOT honour KBUILD_OUTPUT in headers
302 # lets unset it here.
303 unset KBUILD_OUTPUT
304
305 if [[ ${CTARGET} = ${CHOST} ]]; then
306 DEPEND="!virtual/os-headers"
307 PROVIDE="virtual/os-headers"
308 SLOT="0"
309 else
310 SLOT="${CTARGET}"
311 fi
312 else
313 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
314 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
315 fi
316
317 # Cross-compile support functions
318 #==============================================================
319 kernel_header_destdir() {
320 [[ ${CTARGET} == ${CHOST} ]] \
321 && echo /usr/include \
322 || echo /usr/${CTARGET}/usr/include
323 }
324
325 cross_pre_c_headers() {
326 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
327 }
328
329 env_setup_xmakeopts() {
330 # Kernel ARCH != portage ARCH
331 export KARCH=$(tc-arch-kernel)
332
333 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
334 # variables properly or bad things happen !
335 xmakeopts="ARCH=${KARCH}"
336 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
337 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
338 elif type -p ${CHOST}-ar > /dev/null ; then
339 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
340 fi
341 export xmakeopts
342 }
343
344 # Unpack functions
345 #==============================================================
346 unpack_2_4() {
347 # this file is required for other things to build properly,
348 # so we autogenerate it
349 make -s mrproper ${xmakeopts} || die "make mrproper failed"
350 make -s symlinks ${xmakeopts} || die "make symlinks failed"
351 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
352 echo ">>> version.h compiled successfully."
353 }
354
355 unpack_2_6() {
356 # this file is required for other things to build properly, so we
357 # autogenerate it ... generate a .config to keep version.h build from
358 # spitting out an annoying warning
359 make -s mrproper ${xmakeopts} 2>/dev/null \
360 || die "make mrproper failed"
361
362 # quick fix for bug #132152 which triggers when it cannot include linux
363 # headers (ie, we have not installed it yet)
364 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
365 touch .config
366 eerror "make defconfig failed."
367 eerror "assuming you dont have any headers installed yet and continuing"
368 epause 5
369 fi
370
371 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
372 || die "make include/linux/version.h failed"
373 rm -f .config >/dev/null
374 }
375
376 universal_unpack() {
377 cd ${WORKDIR}
378 unpack linux-${OKV}.tar.bz2
379 if [[ -d "linux" ]]; then
380 mv linux linux-${KV_FULL} \
381 || die "Unable to move source tree to ${KV_FULL}."
382 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
383 mv linux-${OKV} linux-${KV_FULL} \
384 || die "Unable to move source tree to ${KV_FULL}."
385 fi
386 cd "${S}"
387
388 # remove all backup files
389 find . -iname "*~" -exec rm {} \; 2> /dev/null
390
391 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
392 sed -i \
393 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
394 "${S}"/arch/ppc/Makefile
395 }
396
397 unpack_set_extraversion() {
398 cd "${S}"
399 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
400 cd "${OLDPWD}"
401 }
402
403 # Should be done after patches have been applied
404 # Otherwise patches that modify the same area of Makefile will fail
405 unpack_fix_install_path() {
406 cd "${S}"
407 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
408 }
409
410 # Compile Functions
411 #==============================================================
412 compile_headers() {
413 env_setup_xmakeopts
414
415 # if we couldnt obtain HOSTCFLAGS from the Makefile,
416 # then set it to something sane
417 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
418 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
419
420 if kernel_is 2 4; then
421 yes "" | make oldconfig ${xmakeopts}
422 echo ">>> make oldconfig complete"
423 make dep ${xmakeopts}
424 elif kernel_is 2 6; then
425 # 2.6.18 introduces headers_install which means we dont need any
426 # of this crap anymore :D
427 kernel_is ge 2 6 18 && return 0
428
429 # autoconf.h isnt generated unless it already exists. plus, we have
430 # no guarantee that any headers are installed on the system...
431 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
432 || touch include/linux/autoconf.h
433
434 # if K_DEFCONFIG isn't set, force to "defconfig"
435 # needed by mips
436 if [[ -z ${K_DEFCONFIG} ]]; then
437 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
438 case ${CTARGET} in
439 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
440 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
441 *) K_DEFCONFIG="defconfig";;
442 esac
443 else
444 K_DEFCONFIG="defconfig"
445 fi
446 fi
447
448 # if there arent any installed headers, then there also isnt an asm
449 # symlink in /usr/include/, and make defconfig will fail, so we have
450 # to force an include path with $S.
451 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
452 ln -sf asm-${KARCH} "${S}"/include/asm
453 cross_pre_c_headers && return 0
454
455 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
456 if compile_headers_tweak_config ; then
457 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
458 fi
459 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
460 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
461 fi
462 }
463
464 compile_headers_tweak_config() {
465 # some targets can be very very picky, so let's finesse the
466 # .config based upon any info we may have
467 case ${CTARGET} in
468 sh*)
469 sed -i '/CONFIG_CPU_SH/d' .config
470 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
471 return 0;;
472 esac
473
474 # no changes, so lets do nothing
475 return 1
476 }
477
478 # install functions
479 #==============================================================
480 install_universal() {
481 #fix silly permissions in tarball
482 cd ${WORKDIR}
483 chown -R root:0 *
484 chmod -R a+r-w+X,u+w *
485 cd ${OLDPWD}
486 }
487
488 install_headers() {
489 local ddir=$(kernel_header_destdir)
490
491 # 2.6.18 introduces headers_install which means we dont need any
492 # of this crap anymore :D
493 if kernel_is ge 2 6 18 ; then
494 env_setup_xmakeopts
495 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
496
497 # let other packages install some of these headers
498 rm -rf "${D}"/${ddir}/sound #alsa-headers
499 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
500 return 0
501 fi
502
503 cd "${S}"
504 dodir ${ddir}/linux
505 cp -pPR "${S}"/include/linux/* ${D}/${ddir}/linux
506 rm -rf ${D}/${ddir}/linux/modules
507
508 # Handle multilib headers and crap
509 local multi_dirs="" multi_defs=""
510 case $(tc-arch-kernel) in
511 sparc64)
512 multi_dirs="sparc sparc64"
513 multi_defs="!__arch64__ __arch64__"
514 ;;
515 x86_64)
516 multi_dirs="i386 x86_64"
517 multi_defs="__i386__ __x86_64__"
518 ;;
519 ppc64)
520 multi_dirs="ppc ppc64"
521 multi_defs="!__powerpc64__ __powerpc64__"
522 ;;
523 s390x)
524 multi_dirs="s390 s390x"
525 multi_defs="!__s390x__ __s390x__"
526 ;;
527 arm)
528 dodir ${ddir}/asm
529 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
530 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
531 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
532 ;;
533 powerpc)
534 dodir ${ddir}/asm
535 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
536 if [[ -e "${S}"/include/asm-ppc ]] ; then
537 dodir ${ddir}/asm-ppc
538 cp -pPR "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
539 fi
540 ;;
541 *)
542 dodir ${ddir}/asm
543 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
544 ;;
545 esac
546 if [[ -n ${multi_dirs} ]] ; then
547 local d ml_inc=""
548 for d in ${multi_dirs} ; do
549 dodir ${ddir}/asm-${d}
550 cp -pPR "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
551
552 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
553 multi_defs=${multi_defs#* }
554 done
555 create_ml_includes ${ddir}/asm ${ml_inc}
556 fi
557
558 if kernel_is 2 6; then
559 dodir ${ddir}/asm-generic
560 cp -pPR "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic
561 fi
562
563 # clean up
564 find "${D}" -name '*.orig' -exec rm -f {} \;
565
566 cd ${OLDPWD}
567 }
568
569 install_sources() {
570 local file
571
572 cd "${S}"
573 dodir /usr/src
574 echo ">>> Copying sources ..."
575
576 file="$(find ${WORKDIR} -iname "docs" -type d)"
577 if [[ -n ${file} ]]; then
578 for file in $(find ${file} -type f); do
579 echo "${file//*docs\/}" >> "${S}"/patches.txt
580 echo "===================================================" >> "${S}"/patches.txt
581 cat ${file} >> "${S}"/patches.txt
582 echo "===================================================" >> "${S}"/patches.txt
583 echo "" >> "${S}"/patches.txt
584 done
585 fi
586
587 if [[ ! -f ${S}/patches.txt ]]; then
588 # patches.txt is empty so lets use our ChangeLog
589 [[ -f ${FILESDIR}/../ChangeLog ]] && \
590 echo "Please check the ebuild ChangeLog for more details." \
591 > "${S}"/patches.txt
592 fi
593
594 mv ${WORKDIR}/linux* ${D}/usr/src
595 }
596
597 # pkg_preinst functions
598 #==============================================================
599 preinst_headers() {
600 local ddir=$(kernel_header_destdir)
601 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
602 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
603 }
604
605 # pkg_postinst functions
606 #==============================================================
607 postinst_sources() {
608 local MAKELINK=0
609
610 # if we have USE=symlink, then force K_SYMLINK=1
611 use symlink && K_SYMLINK=1
612
613 # if we are to forcably symlink, delete it if it already exists first.
614 if [[ ${K_SYMLINK} > 0 ]]; then
615 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
616 MAKELINK=1
617 fi
618
619 # if the link doesnt exist, lets create it
620 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
621
622 if [[ ${MAKELINK} == 1 ]]; then
623 cd ${ROOT}usr/src
624 ln -sf linux-${KV_FULL} linux
625 cd ${OLDPWD}
626 fi
627
628 # Don't forget to make directory for sysfs
629 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
630
631 echo
632 einfo "After installing a new kernel of any version, it is important"
633 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
634 einfo "created (X.Y is the first 2 parts of your new kernel version)"
635 echo
636 einfo "For example, this kernel will require:"
637 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
638 echo
639 einfo "If you are upgrading from a previous kernel, you may be interested"
640 einfo "in the following documents:"
641 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
642 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
643 if kernel_is ge 2 6 13; then
644 ewarn "As of 2.6.13 the support for devfs has been removed."
645 ewarn "You will be required to either manage a static /dev"
646 ewarn "or to ensure that udev is starting on boot."
647 fi
648 echo
649
650 # if K_EXTRAEINFO is set then lets display it now
651 if [[ -n ${K_EXTRAEINFO} ]]; then
652 echo ${K_EXTRAEINFO} | fmt |
653 while read -s ELINE; do einfo "${ELINE}"; done
654 fi
655
656 # if K_EXTRAEWARN is set then lets display it now
657 if [[ -n ${K_EXTRAEWARN} ]]; then
658 echo ${K_EXTRAEWARN} | fmt |
659 while read -s ELINE; do ewarn "${ELINE}"; done
660 fi
661 }
662
663 postinst_headers() {
664 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation"
665 einfo "of newer headers, it is advised that you re-merge glibc as follows:"
666 einfo "emerge glibc"
667 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel"
668 einfo "headers."
669 }
670
671 # pkg_setup functions
672 #==============================================================
673 setup_headers() {
674 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
675 for i in ${H_SUPPORTEDARCH}; do
676 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
677 done
678
679 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
680 echo
681 eerror "This version of ${PN} does not support $(tc-arch)."
682 eerror "Please merge the appropriate sources, in most cases"
683 eerror "(but not all) this will be called $(tc-arch)-headers."
684 die "Package unsupported for $(tc-arch)"
685 fi
686 }
687
688 # unipatch
689 #==============================================================
690 unipatch() {
691 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
692 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
693
694 # set to a standard locale to ensure sorts are ordered properly.
695 myLC_ALL="${LC_ALL}"
696 myLANG="${LANG}"
697 LC_ALL="C"
698 LANG=""
699
700 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
701 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
702
703 # We're gonna need it when doing patches with a predefined patchlevel
704 shopt -s extglob
705
706 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
707 # usage can be either via an env var or by params
708 # although due to the nature we pass this within this eclass
709 # it shall be by param only.
710 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
711 UNIPATCH_LIST="${@}"
712
713 #unpack any passed tarballs
714 for i in ${UNIPATCH_LIST}; do
715 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then
716 extention=${i/*./}
717 extention=${extention/:*/}
718 case ${extention} in
719 tbz2) PIPE_CMD="tar -xvjf";;
720 bz2) PIPE_CMD="tar -xvjf";;
721 tgz) PIPE_CMD="tar -xvzf";;
722 gz) PIPE_CMD="tar -xvzf";;
723 *) eerror "Unrecognized tarball compression"
724 die "Unrecognized tarball compression";;
725 esac
726
727 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
728 unset z
729 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
730 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
731 do z="${z}0";
732 done
733 PATCH_ORDER="${z}${STRICT_COUNT}"
734
735 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
736 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null
737 else
738 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null
739 fi
740
741 if [ $? == 0 ]; then
742 einfo "${i/*\//} unpacked"
743 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
744 else
745 eerror "Failed to unpack ${i/:*/}"
746 die "unable to unpack patch tarball"
747 fi
748 else
749 extention=${i/*./}
750 extention=${extention/:*/}
751 PIPE_CMD=""
752 case ${extention} in
753 bz2) PIPE_CMD="bzip2 -dc";;
754 patch) PIPE_CMD="cat";;
755 diff) PIPE_CMD="cat";;
756 gz|Z|z) PIPE_CMD="gzip -dc";;
757 ZIP|zip) PIPE_CMD="unzip -p";;
758 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
759 esac
760
761 PATCH_LEVEL=${i/*([^:])?(:)}
762 i=${i/:*/}
763 x=${i/*\//}
764 x=${x/\.${extention}/}
765
766 if [ -n "${PIPE_CMD}" ]; then
767 if [ ! -r "${i}" ]; then
768 echo
769 eerror "FATAL: unable to locate:"
770 eerror "${i}"
771 eerror "for read-only. The file either has incorrect permissions"
772 eerror "or does not exist."
773 die Unable to locate ${i}
774 fi
775
776 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
777 unset z
778 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
779 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
780 do z="${z}0";
781 done
782 PATCH_ORDER="${z}${STRICT_COUNT}"
783
784 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
785 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL})
786 else
787 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL})
788 fi
789 fi
790 fi
791 done
792
793 #populate KPATCH_DIRS so we know where to look to remove the excludes
794 x=${KPATCH_DIR}
795 KPATCH_DIR=""
796 for i in $(find ${x} -type d | sort -n); do
797 KPATCH_DIR="${KPATCH_DIR} ${i}"
798 done
799
800 #so now lets get rid of the patchno's we want to exclude
801 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
802 for i in ${UNIPATCH_DROP}; do
803 ebegin "Excluding Patch #${i}"
804 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
805 eend $?
806 done
807
808 # and now, finally, we patch it :)
809 for x in ${KPATCH_DIR}; do
810 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
811 STDERR_T="${T}/${i/*\//}"
812 STDERR_T="${STDERR_T/.patch*/.err}"
813
814 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
815 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
816
817 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
818
819 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
820 while [ ${PATCH_DEPTH} -lt 5 ]; do
821 echo "Attempting Dry-run:" >> ${STDERR_T}
822 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T}
823 echo "=======================================================" >> ${STDERR_T}
824 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
825 echo "Attempting patch:" > ${STDERR_T}
826 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T}
827 echo "=======================================================" >> ${STDERR_T}
828 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
829 eend 0
830 rm ${STDERR_T}
831 break
832 else
833 eend 1
834 eerror "Failed to apply patch ${i/*\//}"
835 eerror "Please attach ${STDERR_T} to any bug you may post."
836 die "Failed to apply ${i/*\//}"
837 fi
838 else
839 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
840 fi
841 done
842 if [ ${PATCH_DEPTH} -eq 5 ]; then
843 eend 1
844 eerror "Please attach ${STDERR_T} to any bug you may post."
845 die "Unable to dry-run patch."
846 fi
847 done
848 done
849
850 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
851 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
852 # which is why I'm not taking too much time over this.
853 local tmp
854 for i in ${UNIPATCH_DOCS}; do
855 tmp="${tmp} ${i//*\/}"
856 cp -f ${i} ${T}/
857 done
858 UNIPATCH_DOCS="${tmp}"
859
860 # clean up KPATCH_DIR's - fixes bug #53610
861 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
862
863 LC_ALL="${myLC_ALL}"
864 LANG="${myLANG}"
865 }
866
867 # getfilevar accepts 2 vars as follows:
868 # getfilevar <VARIABLE> <CONFIGFILE>
869 # pulled from linux-info
870
871 getfilevar() {
872 local workingdir basefname basedname xarch=$(tc-arch-kernel)
873
874 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
875 echo -e "\n"
876 eerror "getfilevar requires 2 variables, with the second a valid file."
877 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
878 else
879 workingdir=${PWD}
880 basefname=$(basename ${2})
881 basedname=$(dirname ${2})
882 unset ARCH
883
884 cd ${basedname}
885 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
886 make ${BUILD_FIXES} -s -f - e 2>/dev/null
887 cd ${workingdir}
888
889 ARCH=${xarch}
890 fi
891 }
892
893 detect_arch() {
894 # This function sets ARCH_URI and ARCH_PATCH
895 # with the neccessary info for the arch sepecific compatibility
896 # patchsets.
897
898 local ALL_ARCH LOOP_ARCH COMPAT_URI i
899
900 # COMPAT_URI is the contents of ${ARCH}_URI
901 # ARCH_URI is the URI for all the ${ARCH}_URI patches
902 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
903
904 ARCH_URI=""
905 ARCH_PATCH=""
906 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
907
908 for LOOP_ARCH in ${ALL_ARCH}; do
909 COMPAT_URI="${LOOP_ARCH}_URI"
910 COMPAT_URI="${!COMPAT_URI}"
911
912 [[ -n ${COMPAT_URI} ]] && \
913 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
914
915 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
916 for i in ${COMPAT_URI}; do
917 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
918 done
919 fi
920 done
921 }
922
923 # sparc nastiness
924 #==============================================================
925 # This script generates the files in /usr/include/asm for sparc systems
926 # during installation of sys-kernel/linux-headers.
927 # Will no longer be needed when full 64 bit support is used on sparc64
928 # systems.
929 #
930 # Shamefully ripped from Debian
931 # ----------------------------------------------------------------------
932
933 # Idea borrowed from RedHat's kernel package
934
935 # This is gonna get replaced by something in multilib.eclass soon...
936 # --eradicator
937 generate_sparc_asm() {
938 local name
939
940 cd $1 || die
941 mkdir asm
942
943 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
944 name="$(echo $h | tr a-z. A-Z_)"
945 # common header
946 echo "/* All asm/ files are generated and point to the corresponding
947 * file in asm-sparc or asm-sparc64.
948 */
949
950 #ifndef __SPARCSTUB__${name}__
951 #define __SPARCSTUB__${name}__
952 " > asm/${h}
953
954 # common for sparc and sparc64
955 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
956 echo "#ifdef __arch64__
957 #include <asm-sparc64/$h>
958 #else
959 #include <asm-sparc/$h>
960 #endif
961 " >> asm/${h}
962
963 # sparc only
964 elif [ -f asm-sparc/$h ]; then
965 echo "#ifndef __arch64__
966 #include <asm-sparc/$h>
967 #endif
968 " >> asm/${h}
969
970 # sparc64 only
971 else
972 echo "#ifdef __arch64__
973 #include <asm-sparc64/$h>
974 #endif
975 " >> asm/${h}
976 fi
977
978 # common footer
979 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
980 done
981 return 0
982 }
983
984 headers___fix() {
985 # Voodoo to partially fix broken upstream headers.
986 # Issues with this function should go to toolchain.
987 sed -i \
988 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
989 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
990 -e "s/ inline / __inline__ /g" \
991 "$@"
992 }
993
994 # common functions
995 #==============================================================
996 kernel-2_src_unpack() {
997 universal_unpack
998 debug-print "Doing unipatch"
999
1000 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1001 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1002
1003 debug-print "Doing premake"
1004
1005 # allow ebuilds to massage the source tree after patching but before
1006 # we run misc `make` functions below
1007 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1008
1009 debug-print "Doing unpack_set_extraversion"
1010
1011 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1012 unpack_fix_install_path
1013
1014 # Setup xmakeopts and cd into sourcetree.
1015 env_setup_xmakeopts
1016 cd "${S}"
1017
1018 # We dont need a version.h for anything other than headers
1019 # at least, I should hope we dont. If this causes problems
1020 # take out the if/fi block and inform me please.
1021 # unpack_2_6 should now be 2.6.17 safe anyways
1022 if [[ ${ETYPE} == headers ]]; then
1023 kernel_is 2 4 && unpack_2_4
1024 kernel_is 2 6 && unpack_2_6
1025 fi
1026 }
1027
1028 kernel-2_src_compile() {
1029 cd "${S}"
1030 [[ ${ETYPE} == headers ]] && compile_headers
1031 }
1032
1033 kernel-2_pkg_preinst() {
1034 [[ ${ETYPE} == headers ]] && preinst_headers
1035 }
1036
1037 kernel-2_src_install() {
1038 install_universal
1039 [[ ${ETYPE} == headers ]] && install_headers
1040 [[ ${ETYPE} == sources ]] && install_sources
1041 }
1042
1043 kernel-2_pkg_postinst() {
1044 [[ ${ETYPE} == headers ]] && postinst_headers
1045 [[ ${ETYPE} == sources ]] && postinst_sources
1046 }
1047
1048 kernel-2_pkg_setup() {
1049 if kernel_is 2 4; then
1050 if [ "$( gcc-major-version )" -eq "4" ] ; then
1051 echo
1052 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1053 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1054 ewarn "newer kernel that supports gcc-4."
1055 echo
1056 ewarn "Also be aware that bugreports about gcc-4 not working"
1057 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1058 echo
1059 epause 10
1060 fi
1061 fi
1062
1063 ABI="${KERNEL_ABI}"
1064 [[ ${ETYPE} == headers ]] && setup_headers
1065 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
1066 }

  ViewVC Help
Powered by ViewVC 1.1.20